public class SPSJava2{
  static int m =0; // Merker fuer Zustaende
  static int SPS(int e){  // Simulation des Schaltnetzes
    int a=0; // Ausgang
    switch (m & 3){
      case 0:
        if((e&1)==1){
          a=a|1;
          m = (m&~3)|1;
        }
      break;
      case 1:
        if((e&1)==0){
          a=a|1;
          m=(m&~3)|2;
        }
      break;
      case 2:
        if((e&1)==1){
          a=a&~1;
          m=(m&~3)|3;
        }
      break;
      case 3:
        if((e&1)==0){
          a=a&~1;  
          m=(m&~3);
        }
    }
    return a;  
  }
  static void test(){  // Ausgabe der Wertetabelle
    test(2,1,1);  // #Merkerbits,Eingangbits,Ausgangbits
  }
  static void test(int mb,int eb,int ab){ // Anzahl Bits der Variablen
    String es="\f Sn|",as="";  // \f loescht Konsole
    int sn;
    for(int i=mb-1;i>=0;i--){  // Tabellenueberschrift Zustandscode
      es=es+'q'+i+' ';
    }
    es=es+'|';
    for(int i=eb-1;i>=0;i--){  // Tabellenueberschrift Eingaenge
      es=es+'X'+i+' ';
    }
    es=es+"||Sn'|";
    for(int i=mb-1;i>=0;i--){  // Tabellenueberschrift Folgezustand
      es=es+'Q'+i+' ';
    }
    es=es+'|';
    for(int i=ab-1;i>=0;i--){  // Tabellenueberschrift Folgezustand
      es=es+'a'+i+' ';
    }
    System.out.println(es);  
    for(sn=0;sn<Math.pow(2,mb);sn++)
      for(int i=0;i<Math.pow(2,eb);i++){
        m=sn;  
        as=intToString2(SPS(i),ab);
        System.out.printf("%3d|%s|%s||%2d |%s|%s %n",sn,intToString2(sn,mb),intToString2(i,eb),m,intToString2(m,mb),as);  
    }  
  }
  static String intToString2(int n,int a){ // formatierte Bitausgabe
    String s="";
    for(int i=0;i<a;i++){
      if(n%2>0)
        s=" 1 "+s;
      else
        s=" 0 "+s;
      n/=2;  
    }
    return s;
  }
}
